Option Explicit

Type POINTAPI
    x As Integer
    y As Integer
End Type

Type RECT
    left As Integer
    top As Integer
    right As Integer
    bottom As Integer
End Type

Type WINDOWPLACEMENT
    length As Integer
    flags As Integer
    showCmd As Integer
    ptMinPosition As POINTAPI
    ptMaxPosition As POINTAPI
    rcNormalPosition As RECT
End Type

' just a few globals
Global Tpx As Integer, Tpy As Integer
Global CD As CommonDialog

Declare Function mbLoWord Lib "ModBlast.vbx" (ByVal dword As Long) As Integer
Declare Function mbHiWord Lib "ModBlast.vbx" (ByVal dword As Long) As Integer
Declare Function mbSetControlFlags Lib "ModBlast.vbx" (ByVal hWnd As Integer, ByVal mask As Long, ByVal value As Long) As Long

Declare Function IsWindowVisible Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function IsIconic Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function IsZoomed Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function GetDeskTopWindow Lib "User" () As Integer
Declare Function GetActiveWindow Lib "User" () As Integer
Declare Sub SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer)
Declare Sub ShowWindow Lib "User" (ByVal hWnd As Integer, ByVal nCmdShow As Integer)
Declare Function GetWindowLong Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer) As Long
Declare Function SetWindowLong Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer, ByVal dwNewLong As Long) As Long
Declare Function GetWindowWord Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer) As Integer
Declare Function GetClassLong Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer) As Long
Declare Function GetDC Lib "User" (ByVal hWnd As Integer) As Integer
Declare Sub ReleaseDC Lib "User" (ByVal hWnd As Integer, ByVal hDC As Integer)
Declare Sub GetWindowPlacement Lib "User" (ByVal hWnd As Integer, lpwndpl As WINDOWPLACEMENT)
Declare Sub SetWindowPlacement Lib "User" (ByVal hWnd As Integer, lpwndpl As WINDOWPLACEMENT)
Declare Sub GetWindowRect Lib "User" (ByVal hWnd As Integer, lpRect As RECT)
Declare Sub GetClientRect Lib "User" (ByVal hWnd As Integer, lpRect As RECT)
Declare Sub CopyRect Lib "User" (lpDestRect As RECT, lpSourceRect As RECT)
Declare Sub InflateRect Lib "User" (lpRect As RECT, ByVal x As Integer, ByVal y As Integer)
Declare Sub FillRect Lib "User" (ByVal hDC As Integer, lpRect As RECT, ByVal hBrush As Integer)
Declare Sub DrawIcon Lib "User" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal hIcon As Integer)
Declare Function Drawtext Lib "User" (ByVal hDC As Integer, ByVal lpStr As String, ByVal nCount As Integer, lpRect As RECT, ByVal wFormat As Integer) As Integer
Declare Sub InvalidateRectbynum Lib "User" Alias "InvalidateRect" (ByVal hWnd As Integer, ByVal lpRect As Long, ByVal bErase As Integer)
Declare Function GetAsyncKeyState Lib "User" (ByVal nVirtKey As Integer) As Integer
Declare Function SetActiveWindow Lib "User" (ByVal hWnd As Integer) As Integer

Declare Sub PostMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any)
Declare Function SendMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any) As Long
Declare Function LoadMenu Lib "User" (ByVal hinstance As Integer, lpString As Long) As Integer
Declare Function GetSystemMenu Lib "User" (ByVal hWnd As Integer, ByVal bRevert As Integer) As Integer
Declare Sub AppendMenu Lib "User" (ByVal hMenu As Integer, ByVal wFlags As Integer, ByVal wIDNewItem As Integer, ByVal lpNewItem As Any)
Declare Function CreateMenu Lib "User" () As Integer
Declare Sub DestroyMenu Lib "User" (ByVal hMenu As Integer)
Declare Function GetMenu Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function GetSubMenu Lib "User" (ByVal hMenu As Integer, ByVal nPos As Integer) As Integer
Declare Sub CheckMenuItem Lib "User" (ByVal hMenu As Integer, ByVal wIDCheckItem As Integer, ByVal wCheck As Integer)
Declare Function TrackPopupMenu Lib "User" (ByVal hMenu As Integer, ByVal wFlags As Integer, ByVal x As Integer, ByVal y As Integer, ByVal nReserved As Integer, ByVal hWnd As Integer, lpReserved As Any) As Integer
Declare Sub ClientToScreenBylong Lib "User" Alias "ClientToScreen" (ByVal hWnd As Integer, lpPoint As Long)
Declare Sub ClientToScreen Lib "User" (ByVal hWnd As Integer, lpPoint As POINTAPI)
Declare Function SelectPalette Lib "User" (ByVal hDC As Integer, ByVal hPalette As Integer, ByVal bForceBackground As Integer) As Integer
Declare Function RealizePalette Lib "User" (ByVal hDC As Integer) As Integer

Declare Function CreateDC Lib "GDI" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, ByVal lpInitData As Long) As Integer
Declare Sub DeleteDC Lib "GDI" (ByVal hDC As Integer)
Declare Function CreateRectRgnIndirect Lib "GDI" (lpRect As RECT) As Integer
Declare Sub CombineRgn Lib "GDI" (ByVal hDestRgn As Integer, ByVal hSrcRgn1 As Integer, ByVal hSrcRgn2 As Integer, ByVal nCombineMode As Integer)
Declare Sub FillRgn Lib "GDI" (ByVal hDC As Integer, ByVal hRgn As Integer, ByVal hBrush As Integer)
Declare Sub BitBlt Lib "GDI" (ByVal hDestDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal dwRop As Long)
Declare Sub SetBkMode Lib "GDI" (ByVal hDC As Integer, ByVal nBkMode As Integer)
Declare Sub SetTextColor Lib "GDI" (ByVal hDC As Integer, ByVal crColor As Long)
Declare Function GetStockObject Lib "GDI" (ByVal nIndex As Integer) As Integer
Declare Function CreateSolidBrush Lib "GDI" (ByVal crColor As Long) As Integer
Declare Sub DeleteObject Lib "GDI" (ByVal hObject As Integer)
Declare Function GetTextExtent Lib "GDI" (ByVal hDC As Integer, ByVal lpString As String, ByVal nCount As Integer) As Long
Declare Sub UpdateColors Lib "GDI" (ByVal hDC As Integer)
Declare Sub UnrealizeObject Lib "GDI" (ByVal hObject As Integer)

Declare Function GetModuleHandle Lib "Kernel" (ByVal lpModuleName As String) As Integer
Declare Function GetModuleUsage Lib "Kernel" (ByVal hModule As Integer) As Integer
Declare Sub FreeLibrary Lib "Kernel" (ByVal hLibModule As Integer)
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpSectionName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function GetPrivateProfileInt Lib "Kernel" (ByVal lpSectionName As String, ByVal lpKeyName As String, ByVal Default As Integer, ByVal lpFileName As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpSectionName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lplFileName As String) As Integer

Declare Sub DragAcceptFiles Lib "Shell" (ByVal hWnd As Integer, ByVal fAccept As Integer)
Declare Function DragQueryFile Lib "Shell" (ByVal hDrop As Integer, ByVal iFile As Integer, ByVal lpszFile As String, ByVal cb As Integer) As Integer
Declare Sub DragFinish Lib "Shell" (ByVal hDrop As Integer)

Global Const SW_HIDE = 0
Global Const SW_SHOWNORMAL = 1
Global Const SW_SHOWMAXIMIZED = 3
Global Const SW_SHOWNOACTIVATE = 4
Global Const SW_SHOW = 5
Global Const SW_SHOWNA = 8

Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2

Global Const SWP_NOMOVE = &H2
Global Const SWP_NOSIZE = &H1
Global Const SWP_NOZORDER = &H4
Global Const SWP_NOACTIVATE = &H10
Global Const SWP_SHOWWINDOW = &H40

Global Const GCL_MENUNAME = (-8)
Global Const GWL_STYLE = (-16)
Global Const GWW_HINSTANCE = (-6)

Global Const WS_VISIBLE = &H10000000
Global Const WS_OVERLAPPED = &H0&
Global Const WS_CAPTION = &HC00000  '  WS_BORDER Or WS_DLGFRAME
Global Const WS_BORDER = &H800000
Global Const WS_SYSMENU = &H80000
Global Const WS_THICKFRAME = &H40000
Global Const WS_MINIMIZEBOX = &H20000
Global Const WS_MAXIMIZEBOX = &H10000
Global Const WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)
Global Const WS_POPUP = &H80000000
Global Const WS_CHILD = &H40000000
Global Const WS_MAXIMIZE = &H1000000

Global Const MF_SEPARATOR = &H800
Global Const MF_ENABLED = &H0
Global Const MF_GRAYED = &H1
Global Const MF_DISABLED = &H2
Global Const MF_UNCHECKED = &H0
Global Const MF_CHECKED = &H8
Global Const MF_BYCOMMAND = &H0
Global Const MF_BYPOSITION = &H400
Global Const MF_USECHECKBITMAPS = &H200

Global Const MF_STRING = &H0
Global Const MF_BITMAP = &H4
Global Const MF_OWNERDRAW = &H100
Global Const MF_POPUP = &H10
Global Const MF_MENUBARBREAK = &H20
Global Const MF_MENUBREAK = &H40

Global Const KEY_ESCAPE = &H1B
Global Const KEY_LEFT = &H25
Global Const KEY_UP = &H26
Global Const KEY_RIGHT = &H27
Global Const KEY_DOWN = &H28

Global Const TRANSPARENT = 1
Global Const BLACK_BRUSH = 4
Global Const NULL_BRUSH = 5
Global Const SRCCOPY = &HCC0020 ' (DWORD) dest = source

Global Const SC_CLOSE = &HF060

Global Const WM_MOVE = &H3
Global Const WM_ACTIVATE = &H6
Global Const WM_SETFOCUS = &H7
Global Const WM_PAINT = &HF
Global Const WM_ERASEBKGND = &H14
Global Const WM_CTLCOLOR = &H19
Global Const WM_MOUSEACTIVATE = &H21
Global Const WM_LBUTTONDOWN = &H201
Global Const WM_LBUTTONDBLCLK = &H203
Global Const WM_RBUTTONDOWN = &H204
Global Const WM_NCHITTEST = &H84
Global Const WM_COMMAND = &H111
Global Const WM_SYSCOMMAND = &H112
Global Const WM_INITMENU = &H116
Global Const WM_MENUSELECT = &H11F
Global Const WM_NCLBUTTONDBLCLK = &HA3
Global Const WM_NCRBUTTONDOWN = &HA4
Global Const WM_PALETTECHANGED = &H311
Global Const WM_QUERYNEWPALETTE = &H30F
Global Const WM_DROPFILES = &H233

Global Const VBM_PALETTECHANGED = &H101B
Global Const VBM_GETPALETTE = &H101C

Global Const HTTRANSPARENT = (-1)
Global Const HTCLIENT = 1
Global Const HTCAPTION = 2

Global Const MA_NOACTIVATE = 3

Global Const RGN_DIFF = 4

Global Const VK_SHIFT = &H10

Global Const CTLFLG_HASPALETTE = 1
Global Const CTLFLG_USESPALETTE = 2

Global Const DT_WORDBREAK = &H10
Global Const DT_CENTER = &H1


'-----------------------------------
'Common Dialog Control
'-----------------------------------
'Action Property
Global Const DLG_FILE_OPEN = 1
Global Const DLG_FILE_SAVE = 2
Global Const DLG_COLOR = 3
Global Const DLG_FONT = 4
Global Const DLG_PRINT = 5
Global Const DLG_HELP = 6

'File Open/Save Dialog Flags
Global Const OFN_READONLY = &H1&
Global Const OFN_OVERWRITEPROMPT = &H2&
Global Const OFN_HIDEREADONLY = &H4&
Global Const OFN_NOCHANGEDIR = &H8&
Global Const OFN_SHOWHELP = &H10&
Global Const OFN_NOVALIDATE = &H100&
Global Const OFN_ALLOWMULTISELECT = &H200&
Global Const OFN_EXTENTIONDIFFERENT = &H400&
Global Const OFN_PATHMUSTEXIST = &H800&
Global Const OFN_FILEMUSTEXIST = &H1000&
Global Const OFN_CREATEPROMPT = &H2000&
Global Const OFN_SHAREAWARE = &H4000&
Global Const OFN_NOREADONLYRETURN = &H8000&

'Color Dialog Flags
Global Const CC_RGBINIT = &H1&
Global Const CC_FULLOPEN = &H2&
Global Const CC_PREVENTFULLOPEN = &H4&
Global Const CC_SHOWHELP = &H8&

'Fonts Dialog Flags
Global Const CF_SCREENFONTS = &H1&
Global Const CF_PRINTERFONTS = &H2&
Global Const CF_BOTH = &H3&
Global Const CF_SHOWHELP = &H4&
Global Const CF_INITTOLOGFONTSTRUCT = &H40&
Global Const CF_USESTYLE = &H80&
Global Const CF_EFFECTS = &H100&
Global Const CF_APPLY = &H200&
Global Const CF_ANSIONLY = &H400&
Global Const CF_NOVECTORFONTS = &H800&
Global Const CF_NOSIMULATIONS = &H1000&
Global Const CF_LIMITSIZE = &H2000&
Global Const CF_FIXEDPITCHONLY = &H4000&
Global Const CF_WYSIWYG = &H8000&                        'must also have CF_SCREENFONTS & CF_PRINTERFONTS
Global Const CF_FORCEFONTEXIST = &H10000
Global Const CF_SCALABLEONLY = &H20000
Global Const CF_TTONLY = &H40000
Global Const CF_NOFACESEL = &H80000
Global Const CF_NOSTYLESEL = &H100000
Global Const CF_NOSIZESEL = &H200000

